# run any dev things if there is a creative player
# @s = unspecified
# at unspecified
# run from main

# show IDs to creative devs
execute as @a[gamemode=creative,team=dev,tag=gm4_actionbar,nbt=!{SelectedItem:{id:"minecraft:debug_stick"}}] at @s run title @s actionbar [{"text":"$id: ","color":"dark_gray"},{"score":{"name":"$id","objective":"gm4_pb_id"},"color":"gray"},{"text":" | Nearest block: "},{"score":{"name":"@e[type=marker,tag=gm4_pb_block,limit=1,sort=nearest]","objective":"gm4_pb_id"},"color":"gray"},{"text":" | Respawn: "},{"score":{"name":"@e[type=marker,tag=gm4_pb_possible_respawn,limit=1,sort=nearest]","objective":"gm4_pb_id"},"color":"gray"},{"text":" | Goal: "},{"score":{"name":"@e[type=item_display,tag=gm4_pb_goals,limit=1,sort=nearest]","objective":"gm4_pb_id"},"color":"gray"}]

# build teleporter and keep color updated
execute as @e[type=bat,tag=gm4_pb_teleporter] at @s align xyz run function gm4_puzzle_block:dev/spawn_teleporter
execute as @e[type=item_display,tag=gm4_pb_teleporter] store result score @s gm4_pb_data run data get entity @s item.tag.display.color
# build button
execute as @e[type=bat,tag=gm4_pb_button] at @s run function gm4_puzzle_block:dev/check_button
# build plug
execute as @e[type=bat,tag=gm4_pb_plug] at @s run function gm4_puzzle_block:dev/check_plug
# build lamp
execute as @e[type=bat,tag=gm4_pb_lamp] at @s run function gm4_puzzle_block:dev/check_lamp
# build icon
execute as @e[type=bat,tag=gm4_pb_icon] at @s run function gm4_puzzle_block:dev/check_icon
# build secret
execute as @e[type=bat,tag=gm4_pb_secret] at @s align xyz positioned ~0.5 ~0.5 ~0.5 summon item_display run function gm4_puzzle_block:dev/spawn_secret
kill @e[type=bat,tag=gm4_pb_secret]
# build box (spawner)
execute as @e[type=bat,tag=gm4_pb_block.box] at @s align xyz positioned ~0.5 ~0.5 ~0.5 summon marker run function gm4_puzzle_block:dev/spawn_box
kill @e[type=bat,tag=gm4_pb_block.box]
execute as @e[type=bat,tag=gm4_pb_block.box_spawner] at @s align xyz positioned ~.5 ~.5 ~.5 summon marker run function gm4_puzzle_block:dev/spawn_box_spawner
# build lamp (spawner)
execute as @e[type=bat,tag=gm4_pb_block.lamp] at @s align xyz positioned ~0.5 ~0.5 ~0.5 summon marker run function gm4_puzzle_block:dev/spawn_lamp
kill @e[type=bat,tag=gm4_pb_block.lamp]
execute as @e[type=bat,tag=gm4_pb_block.lamp_spawner] at @s align xyz positioned ~.5 ~.5 ~.5 summon marker run function gm4_puzzle_block:dev/spawn_lamp_spawner
# build crate (spawner)
execute as @e[type=bat,tag=gm4_pb_block.crate] at @s align xyz positioned ~0.5 ~0.5 ~0.5 summon marker run function gm4_puzzle_block:dev/spawn_crate
kill @e[type=bat,tag=gm4_pb_block.crate]
execute as @e[type=bat,tag=gm4_pb_block.crate_spawner] at @s align xyz positioned ~.5 ~.5 ~.5 summon marker run function gm4_puzzle_block:dev/spawn_crate_spawner
# build door
execute as @e[type=bat,tag=gm4_pb_door.uninit] at @s run function gm4_puzzle_block:dev/door_setup/init
# build bench
execute as @e[type=armor_stand,tag=gm4_pb_bench] at @s run function gm4_puzzle_block:dev/spawn_bench
# init piston
execute as @e[type=bat,tag=gm4_pb_piston] at @s run function gm4_puzzle_block:dev/check_piston
# init birb
execute as @e[type=armor_stand,tag=gm4_pb_birb] at @s run function gm4_puzzle_block:dev/spawn_birb
# init magnet
execute as @e[type=bat,tag=gm4_pb_magnet] at @s run function gm4_puzzle_block:dev/check_magnet
# init respawn point and show active one to devs
execute as @e[type=armor_stand,tag=gm4_pb_new_respawn] at @s run function gm4_puzzle_block:dev/initiate_respawn
execute at @e[type=marker,tag=gm4_pb_respawn] run particle happy_villager ~ ~ ~ 0.2 0.5 0.2 0 1 force @a[gamemode=!adventure,team=dev]

# remove push blocks that have been punched out
execute as @e[type=marker,tag=gm4_pb_block] at @s if block ~ ~ ~ air run function gm4_puzzle_block:dev/delete_block
# remove teleporters that have been punched out
execute as @e[type=item_display,tag=gm4_pb_teleporter] at @s if block ~ ~ ~ air run kill @s
# remove pistons that have been punched out
execute as @e[type=item_display,tag=gm4_pb_piston] at @s if block ^ ^ ^-1 air run kill @s
# remove benches that have been punched out
execute as @e[type=pig,tag=gm4_pb_bench] at @s unless block ~ ~.5 ~ campfire unless block ~ ~25.5 ~ campfire run kill @s
execute as @e[type=block_display,tag=gm4_pb_bench] at @s unless block ~ ~ ~ campfire run kill @s
# remove buttons/icons/plugs/lamps that have been punched out
execute as @e[type=item_display,tag=gm4_pb_icon] at @s if block ^ ^ ^-1 air run kill @s
execute as @e[type=item_display,tag=gm4_pb_lamp] at @s if block ^ ^ ^-1 air run setblock ~ ~ ~ air
execute as @e[type=item_display,tag=gm4_pb_lamp] at @s if block ^ ^ ^-1 air run kill @s
execute as @e[type=item_display,tag=gm4_pb_goals] at @s if block ^ ^ ^-1 air run kill @s
# show doors
execute at @e[type=marker,tag=gm4_pb_door] run particle electric_spark ~ ~ ~ 0 0 0 0 0 force @a[gamemode=!adventure,team=dev]
execute as @e[type=marker,tag=gm4_pb_door] at @s if block ~ ~ ~ bedrock run kill @s
# remove doors
execute as @e[type=item_display,tag=gm4_pb_door.display] at @s unless entity @e[type=marker,tag=gm4_pb_door,distance=..0.2] run kill @s
# remove birbs
execute as @e[type=item_display,tag=gm4_pb_birb] at @s if block ~ ~ ~ bedrock run kill @s
# remove collectables
execute as @e[type=item_display,tag=gm4_pb_secret] at @s if block ~ ~ ~ bedrock run kill @s
# show collectables
execute at @e[type=item_display,tag=gm4_pb_secret.disabled] run particle wax_on ~ ~ ~ 0 0 0 0 0 force @a[team=dev]
# show nearest respawn
execute as @a[team=dev,nbt={SelectedItem:{id:"minecraft:light"}}] at @s at @e[type=marker,tag=gm4_pb_possible_respawn,limit=1,sort=nearest] run particle wax_on ~ ~ ~ 0.1 0.1 0.1 0 1 force @s

# show/hide armor stands to allow removal
execute as @a[gamemode=creative,team=dev,nbt={SelectedItem:{id:"minecraft:barrier"}}] at @s as @e[type=marker,tag=!gm4_pb_dev_entity.vis,tag=gm4_pb_dev_entity,distance=..16] at @s run function gm4_puzzle_block:dev/reveal_dev_entity
execute as @e[type=marker,tag=gm4_pb_dev_entity.vis] at @s unless entity @a[gamemode=creative,team=dev,nbt={SelectedItem:{id:"minecraft:barrier"}},distance=..16] run function gm4_puzzle_block:dev/hide_dev_entity
execute as @e[type=marker,tag=gm4_pb_dev_entity.vis] at @s unless entity @e[type=armor_stand,tag=gm4_pb_dev_entity,distance=..0.1] run kill @s

# show hidden buttons
execute at @e[type=item_display,tag=gm4_pb_button.hidden] run particle scrape ^ ^ ^-.35 0 0 0 0 0 force @a[gamemode=!adventure,team=dev]

# invulnerable decor
execute as @e[type=#gm4_puzzle_block:decor,tag=!gm4_ba_decor] run function gm4_puzzle_block:better_adventure/decor/make_invulnerable
