# remove old box hitbox and displays
# @s = puzzle block marker
# at @s
# run from dev/delete_block
# run from any mechanic/conveyor/DIRECTION
# run from mechanic/elevator/apply
# run from mechanic/gravity/apply
# run from any mechanic/ice/DIRECTION
# run from any in mechanic/piston/apply/
# run from any mechanic/pusher/DIRECTION
# run from mechanic/teleporter/apply
# run from mechanic/reset/block_up
# run from mechanic/reset/block_pos
# run from mechanic/undo/restore/block

# if block was disabled first enable it
execute if entity @s[type=marker,tag=gm4_pb_block.disabled] run function gm4_puzzle_block:technical/block/enable

# replace block
execute unless score @s[tag=!gm4_pb_puzzle_waterlogged] gm4_pb_replace_block matches 1.. run setblock ~ ~ ~ air
execute unless score @s[tag=gm4_pb_puzzle_waterlogged] gm4_pb_replace_block matches 1.. run setblock ~ ~ ~ water
execute if entity @s[tag=!gm4_pb_puzzle_waterlogged,scores={gm4_pb_replace_block=1..}] run function gm4_puzzle_block:mechanic/move/restore_block
execute if entity @s[tag=gm4_pb_puzzle_waterlogged,scores={gm4_pb_replace_block=1..}] run function gm4_puzzle_block:mechanic/move/restore_waterlogged_block

# unblock teleporters
tag @s[tag=gm4_pb_block.tp_cooldown,scores={gm4_pb_replace_block=1}] add gm4_check_tp
tag @s remove gm4_pb_block.tp_cooldown
execute if entity @s[tag=gm4_check_tp] as @e[type=item_display,tag=gm4_pb_teleporter,distance=..0.1] run function gm4_puzzle_block:mechanic/teleporter/unblock_check
tag @s remove gm4_check_tp

# tag block displays to be checked
tag @e[type=item_display,tag=gm4_pb_block_display,distance=..1.5] add gm4_pb_block_display.check

# magnet beams
execute if entity @e[type=item_display,tag=gm4_pb_magnet.beam,distance=..1.3] as @e[type=slime,tag=gm4_pb_magnet] if predicate gm4_puzzle_block:puzzle_blocks/magnet_in_range run tag @s add gm4_pb_magnet.rebeam

# clear replacement block displays at the start of the next tick
execute if score @s gm4_pb_replace_block matches 1.. align xyz run tag @e[type=block_display,tag=gm4_pb_replace_display,dx=0,dy=0,dz=0] add gm4_pb_delete

# clear data
scoreboard players reset @s gm4_pb_replace_block
scoreboard players set @s[tag=!gm4_pb_teleporting] gm4_pb_auto_move 0
tag @s remove gm4_pb_puzzle_waterlogged

# turn off lamp
execute if entity @s[tag=gm4_pb_block.lamp.active] run function gm4_puzzle_block:technical/block/turn_off_lamp
tag @s remove gm4_pb_block.lamp.checked

# tag nearby blocks
tag @e[type=marker,tag=gm4_pb_block,distance=..1.75] add gm4_pb_block.move_check
