# apply teleportation
# @s = puzzle block marker
# at target teleporter item_display
# run from mechanic/teleporter/check

# remove block from old location
tag @s add gm4_pb_teleporting
execute at @s run function gm4_puzzle_block:mechanic/move/remove_old
tag @s remove gm4_pb_teleporting

# mark this tp (unless there are other free tp's) and arrival tp for blocking
execute unless entity @e[type=item_display,tag=gm4_pb_possible_tp,distance=0.1..] at @s run tag @e[type=item_display,tag=gm4_pb_teleporter,tag=!gm4_pb_teleporter.blocked,distance=..0.1] add gm4_block_this_tp
tag @e[type=item_display,tag=gm4_pb_teleporter,tag=!gm4_pb_teleporter.blocked,distance=..0.1] add gm4_block_this_tp

# vfx
execute at @s run playsound minecraft:entity.allay.item_given block @a ~ ~ ~ 1.5 0.5
playsound minecraft:entity.allay.item_taken block @a ~ ~ ~ 1.5 0.5

# animate movement
scoreboard players set @s gm4_pb_moving 11
execute at @s run scoreboard players set @e[type=item_display,tag=gm4_pb_block_display,tag=!gm4_pb_delete,tag=!gm4_pb_block_display.air,limit=1,sort=nearest,distance=..2] gm4_pb_moving 10
execute at @s run data merge entity @e[type=item_display,tag=gm4_pb_block_display,tag=!gm4_pb_delete,tag=!gm4_pb_block_display.air,limit=1,sort=nearest,distance=..2] {start_interpolation:-1,interpolation_duration:10,transformation:{translation:[-.05f,-.05f,-.05f],scale:[0.1f,0.1f,0.1f]}}

# place display to grow next tick and item_display for later
summon item_display ~ ~ ~ {view_range:0.625f,Tags:["gm4_pb_block_display","gm4_pb_tp_display"],transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[-.05f,-.05f,-.05f],scale:[0.1f,0.1f,0.1f]},item:{id:"minecraft:brown_dye"}}
data modify entity @e[type=item_display,tag=gm4_pb_tp_display,tag=!gm4_pb_delete,tag=!gm4_pb_block_display.air,limit=1,sort=nearest,distance=..2] item set from entity @s data.gm4_puzzle_block.display_data
summon item_display ~ ~ ~ {view_range:0.625f,Tags:["gm4_pb_block_display","gm4_pb_block_display.air"],transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],translation:[-.0005f,-.0005f,-.0005f],scale:[1.001f,1.001f,1.001f]},item:{id:"minecraft:air"}}

# move block here
scoreboard players set @s gm4_pb_replace_block 1
tag @s add gm4_pb_block.tp_cooldown
setblock ~ ~ ~ dark_oak_leaves[persistent=false]
tp @s ~ ~ ~

# check for ice
execute unless block ~ ~-1 ~ #gm4_puzzle_block:ice run scoreboard players set @s[scores={gm4_pb_auto_move=1..4}] gm4_pb_auto_move 0

# block tp's marked for blocking (doing this at the end because the block needs to have moved)
execute as @e[type=item_display,tag=gm4_block_this_tp] at @s run function gm4_puzzle_block:mechanic/teleporter/block

execute unless score $advancement.teleporter gm4_pb_data matches 1 run function gm4_puzzle_block:technical/advancements/teleporter
